<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
	<NuxtLayout name="default">
		<div>

			<!-- sidebar navigation teleported to template -->
			<SidebarNav :nav="navItems" :title="'Glossary'" />
			<TopbarTopBar :breadcrumb="breadcrumb" @edit-click="openEditModal" @delete-click="openDeleteModal" />
			<div class="detail-header">
				<div class="row">
					<div class="col-xl-12">
						<div class="title">
							<h2>{{ glossaryDetails?.name }}</h2>
							<span class="type-term">Term</span>
						</div>
					</div>
				</div>
			</div>
			<div class="detail-body">
				<div class="row">
					<div class="col-xl-3">
						<div class="about">
							<InfoBox title="Creation date" :text="formatDate(glossaryDetails?.createdAt)" />
							<InfoBox title="Last Edition" :text="formatDate(glossaryDetails?.updatedAt)" />
						</div>
						<div class="info user">
							<h3>Owner</h3>
							<UserProfile />
						</div>
						<div class="info user">
							<h3>Shared with</h3>
							<UsersSelectionList />
						</div>
					</div>
					<div class="col-xl-8 offset-xl-1">
						<div class="row">
							<div class="col-xl-9">
								<EditableTextBox title="Full description" :text="glossaryDetails?.description" />
								<EditableTextBox title="Short description" :text="glossaryDetails?.summary" />
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="detail-tab">
				<TabsGlossaryDetailTabs :data="glossaryDetails" :key="glossaryDetails?.id" :terms="true" />
			</div>
			<div class="container">
				<div class="offset-xl-1 col-xl-10 mt-160">
					<BannersBannerCta :banners="BannerCta" />
				</div>
			</div>
			<ClientOnly>
				<Teleport to="#modals-container">
					<ModalsCreateTerm v-if="showCreateTermModal" @toggle="close" :glossaryId="glossaryDetails?.id" :isEditMode="isEditMode" :row="route.params.id.toString()" />
					<ModalsModalDelete v-if="showDeleteModal" @toggle="closeDelete" :value="route.params.id.toString()" type="Term" :parentId="glossaryDetails?.glossary?.id" />
				</Teleport>
			</ClientOnly>
		</div>
	</NuxtLayout>
</template>
<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';
import type NavItemI from '~/interfaces/navItem';
import type sliderItemI from '~/interfaces/sliderItem';
import slide1 from '@/assets/images/slide1.png';
import { useRoute } from 'vue-router';
import { formatDate, removeHtmlTags } from '~/utils/utils';
import { storeToRefs } from 'pinia';
import { useDataStore } from '@/stores/dataStore';

const route = useRoute();
const dataStore = useDataStore();
const { refreshKey } = storeToRefs(dataStore); 

const showCreateTermModal = ref(false);

// Define Breadcrumb interface
interface BreadcrumbI {
    title: string;
    link: string;
}

const breadcrumb = ref<any>([]);
const isEditMode = ref(false);
const showDeleteModal = ref(false);

const closeDelete = () => {
    showDeleteModal.value = false;
};

const openDeleteModal = () => {
	showDeleteModal.value = true;
};

const close = () => {
	showCreateTermModal.value = false;
	isEditMode.value = false;
};

const openEditModal = () => {
	showCreateTermModal.value = true;
	isEditMode.value = true;
};

/** GLOSSARY - get glossary details **/

const glossaryDetails = ref<any>(null);
const terms = ref<any>([]);

async function fetchData() {
	if (route.params.id) {
		try {
			const response = await useFetchAuth(`/terms/${route.params.id}`);
			glossaryDetails.value = response || {};
			data.value.rows = glossaryDetails.value?.terms || [];
			console.log(2, glossaryDetails.value);
			data.value.rows?.map((term: any) => {
				term.type = "Term"
			})
			breadcrumb.value = [
				{
					title: 'Glossary',
					link: '/glossary'
				},
				{
					title: 'All terms',
					link: '/glossary/terms'
				},
				{
					title: glossaryDetails.value?.name,
					link: '#'
				}
			]

		} catch (error) {
			console.error('Error fetching data:', error);
			glossaryDetails.value = {}; // Set to an empty object to prevent issues
		}
	}
}

onMounted(() => {
	fetchData();
});

watch(() => route.params.id, () => {
	fetchData();
}, { immediate: true });

watch(refreshKey, async(newKey) => {
	console.log('refreshKey', newKey);
	await fetchData();
});

const viewDefault = () => {
	console.log('show default home page');
}

const dummyClick = () => {
	console.log('dummyClick');
}

const goToGlossary = () => {
    navigateTo('/glossary');
}

const goToAllTerms = () => {
    navigateTo('/glossary/terms');
}

const navItems = ref<NavItemI[]>([
    {
        label: 'Glossary',
        icon: 'vocabularies_nav',
        action: goToGlossary,
    }, {
        label: 'All terms',
        icon: 'clock',
        action: goToAllTerms,
        active: true
    },
    {
        label: 'Recently viewed',
        icon: 'clock',
        action: dummyClick
    },
    {
        label: 'Highlighted',
        icon: 'favourite',
        action: dummyClick
    },
    {
        label: 'Your Catalog',
        icon: 'loading',
        action: dummyClick
    }
]);

const BannerCta = ref<sliderItemI[]>([
	{
		id: 1,
		title: 'Have a question or doubts?',
		text: 'Check our FAQs and Documentation',
		button_text: 'Faqs and Documentation',
		button_link: 'https://www.google.com',
		media_type: 1,
		media_url: slide1,
		template: 1,
	}
])

const data = ref<DataTableI>({
	options: {
		tableName: 'glossary-table',
		detailsPath: '',
		allowCheckRow: true,
		favourites: true,
		previewComponent: 'GlossaryDetails',
	},
	columns: [
		{
			id: 1,
			name: 'name',
			label: 'Name',
			combineColumn: 'type',
			renderComponent: 'TableColumnsName',
			width: '100px'
		},
		{
			id: 2,
			name: 'group',
			label: 'Group',
			width: '180px'
		},
		{
			id: 3,
			name: 'domain',
			label: 'Domain',
			width: '180px'
		},
		{
			id: 4,
			name: 'description',
			label: 'Description',
			width: '180px'
		},
		{
			id: 5,
			name: 'edited_at',
			label: 'Edited at',
			width: '160px'
		},
		{
			id: 6,
			name: 'actions',
			label: 'Actions',
			width: '80px',
			hideLabel: true
		}
	],
	rows: []
});

</script>